<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>OrderedExecutionMultiExchange.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.exchanges.executor</a> &gt; <span class="el_source">OrderedExecutionMultiExchange.java</span></div><h1>OrderedExecutionMultiExchange.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.exchanges.executor;

import java.util.Objects;
import java.util.concurrent.atomic.AtomicReferenceArray;
import java.util.function.Consumer;
import java.util.function.IntFunction;
import java.util.function.Supplier;
import java.util.function.ToIntFunction;
import java.util.stream.IntStream;

import io.gitlab.littlesaints.protean.Processor;
import io.gitlab.littlesaints.protean.exchanges.MessageExchange;

/**
 * This executor performs ordered executions.
 * The order of execution for submitted objects is determined by a orderResolver. This orderResolver is provided during the instantiation of this executor.
 *
 * @param &lt;E&gt; The getType of objects to execute upon.
 * @author Varun Anand
 * @since 1.0
 *
 */
class OrderedExecutionMultiExchange&lt;E&gt; extends AbstractExecutionExchange&lt;E&gt; {

    public static final String TYPE = &quot;exchange::execution::java::ordered::multi&quot;;

    private static final String nameSuffix = &quot;::OrderedExecutionExchange-multi&quot;;

    private final Reader&lt;E&gt; reader;

    private final AtomicReferenceArray&lt;Thread&gt; workers;
    private final AtomicReferenceArray&lt;Runnable&gt; onCloseOps;

    private final int bufferSize;
    private final boolean lazyRoutes;

    private final ToIntFunction&lt;E&gt; orderResolver;

    private final AtomicReferenceArray&lt;Reader&lt;E&gt;&gt; outputExchangeReaders;
    private final AtomicReferenceArray&lt;Writer&lt;E&gt;&gt; outputExchangeWriters;

    private final AtomicReferenceArray&lt;Reader&lt;E&gt;&gt; inputExchangeReaders;
    private final AtomicReferenceArray&lt;Writer&lt;E&gt;&gt; inputExchangeWriters;

    private final AtomicReferenceArray&lt;MessageExchange&lt;E&gt;&gt; inputExchanges;
    private final AtomicReferenceArray&lt;MessageExchange&lt;E&gt;&gt; outputExchanges;

    /**
     * Construct an executor
     *
     * @param name             the name of this exchange. Pass null, if no specific value is needed.
     * @param concurrency      the 'fixed' number of threads to use
     * @param bufferSize       the buffer size of each thread's message exchange
     * @param exchangeSupplier the supplier function for creating a message exchange
     * @param processorSupplier   the action to perform on a submitted object/event
     * @param orderResolver    the function to resolve the order of execution for submitted objects/events.
     */
    OrderedExecutionMultiExchange(String name, int concurrency, int bufferSize, IntFunction&lt;MessageExchange&lt;E&gt;&gt; exchangeSupplier, Supplier&lt;Processor&lt;E&gt;&gt; processorSupplier,
                                  ToIntFunction&lt;E&gt; orderResolver, boolean lazyRoutes) {
<span class="fc" id="L80">        super(name + nameSuffix, processorSupplier, concurrency, exchangeSupplier);</span>
<span class="fc" id="L81">        this.bufferSize = bufferSize;</span>
<span class="fc" id="L82">        this.orderResolver = orderResolver;</span>
<span class="fc" id="L83">        inputExchanges = new AtomicReferenceArray&lt;&gt;(concurrency);</span>
<span class="fc" id="L84">        outputExchanges = new AtomicReferenceArray&lt;&gt;(concurrency);</span>

<span class="fc" id="L86">        reader = new _Reader();</span>
<span class="fc" id="L87">        workers = new AtomicReferenceArray&lt;&gt;(concurrency);</span>
<span class="fc" id="L88">        onCloseOps = new AtomicReferenceArray&lt;&gt;(concurrency);</span>

<span class="fc" id="L90">        outputExchangeReaders = new AtomicReferenceArray&lt;&gt;(concurrency);</span>
<span class="fc" id="L91">        outputExchangeWriters = new AtomicReferenceArray&lt;&gt;(concurrency);</span>
<span class="fc" id="L92">        inputExchangeReaders = new AtomicReferenceArray&lt;&gt;(concurrency);</span>
<span class="fc" id="L93">        inputExchangeWriters = new AtomicReferenceArray&lt;&gt;(concurrency);</span>

<span class="fc" id="L95">        this.lazyRoutes = lazyRoutes;</span>
<span class="pc bpc" id="L96" title="1 of 2 branches missed.">        if (!lazyRoutes) {</span>
<span class="fc" id="L97">            IntStream.range(0, concurrency).forEach(r -&gt; {</span>
<span class="fc" id="L98">                this.initRoute(r);</span>
<span class="fc" id="L99">                this.initRouteProcessor(r);</span>
<span class="fc" id="L100">            });</span>
        }
<span class="fc" id="L102">    }</span>

    @Override
    public Reader&lt;E&gt; getReader() {
<span class="fc" id="L106">        return reader;</span>
    }

    @Override
    public Writer&lt;E&gt; newWriter() {
<span class="fc" id="L111">        return new _Writer();</span>
    }

<span class="fc" id="L114">    private class _Reader extends _ExecutionExchangeReader {</span>
        @Override
        Reader&lt;E&gt; getOutputExchangeReader(int idx) {
<span class="fc" id="L117">            return outputExchangeReaders.get(idx);</span>
        }
    }

<span class="fc" id="L121">    private class _Writer implements Writer&lt;E&gt; {</span>
        @Override
        public boolean put(final E e) {
<span class="fc" id="L124">            int route = orderResolver.applyAsInt(e) &amp; (concurrency - 1);</span>
<span class="pc bpc" id="L125" title="1 of 2 branches missed.">            if (lazyRoutes) {</span>
<span class="nc" id="L126">                initRoute(route);</span>
            }
<span class="fc" id="L128">            initRouteProcessor(route);</span>
<span class="fc" id="L129">            inputExchangeWriters.get(route).put(e);</span>
<span class="fc" id="L130">            return true;</span>
        }
    }

    private void initRoute(int route) {
<span class="fc" id="L135">        MessageExchange&lt;E&gt; inputExchange = exchangeSupplier.apply(bufferSize);</span>
<span class="pc bpc" id="L136" title="1 of 2 branches missed.">        if (inputExchangeReaders.compareAndSet(route, null, inputExchange.getReader())) {</span>
<span class="fc" id="L137">            inputExchangeWriters.lazySet(route, inputExchange.newWriter());</span>

<span class="fc" id="L139">            MessageExchange&lt;E&gt; outputExchange = exchangeSupplier.apply(bufferSize);</span>
<span class="fc" id="L140">            outputExchangeReaders.lazySet(route, outputExchange.getReader());</span>
<span class="fc" id="L141">            outputExchangeWriters.lazySet(route, outputExchange.newWriter());</span>

<span class="fc" id="L143">            inputExchanges.set(route, inputExchange);</span>
<span class="fc" id="L144">            outputExchanges.set(route, outputExchange);</span>
<span class="fc" id="L145">        } else {</span>
<span class="nc bnc" id="L146" title="All 2 branches missed.">            while (outputExchangeWriters.get(route) == null) {</span>
<span class="nc" id="L147">                Thread.yield();</span>
            }
        }
<span class="fc" id="L150">    }</span>

    //TODO watcher for thread liveness

    private void initRouteProcessor(int route) {

<span class="fc" id="L156">        Thread worker = workers.get(route);</span>
<span class="pc bpc" id="L157" title="1 of 4 branches missed.">        if (worker == null || !worker.isAlive()) {</span>
<span class="fc" id="L158">            final Reader&lt;E&gt; inputExchangeReader = inputExchangeReaders.get(route);</span>
<span class="fc" id="L159">            final Writer&lt;E&gt; outputExchangeWriter = outputExchangeWriters.get(route);</span>
<span class="fc" id="L160">            final Processor&lt;E&gt; processor = processorSupplier.get();</span>
<span class="fc" id="L161">            final Consumer&lt;E&gt; action = processor.getFunction()::apply;</span>
<span class="fc" id="L162">            final Thread newWorker = new Thread(() -&gt;</span>
<span class="nc" id="L163">                    inputExchangeReader.take(e -&gt; {</span>
<span class="fc" id="L164">                        action.accept(e);</span>
<span class="fc" id="L165">                        outputExchangeWriter.put(e);</span>
<span class="fc" id="L166">                        return true;</span>
<span class="fc" id="L167">                    }), getName() + &quot;-worker-&quot; + route);</span>

<span class="pc bpc" id="L169" title="1 of 2 branches missed.">            if (workers.compareAndSet(route, worker, newWorker)) {</span>
<span class="pc bpc" id="L170" title="1 of 2 branches missed.">                if (worker != null) {</span>
<span class="nc" id="L171">                    onCloseOps.get(route).run();</span>
                }
<span class="fc" id="L173">                onCloseOps.lazySet(route, processor::close);</span>
<span class="fc" id="L174">                newWorker.start();</span>
            }
        }
<span class="fc" id="L177">    }</span>

    @Override
    public void shutdown() {
<span class="nc" id="L181">        IntStream.range(0, concurrency)</span>
<span class="nc" id="L182">                .boxed()</span>
<span class="nc" id="L183">                .map(inputExchanges::get)</span>
<span class="nc" id="L184">                .filter(Objects::nonNull)</span>
<span class="nc" id="L185">                .forEach(MessageExchange::shutdown);</span>
<span class="nc" id="L186">        IntStream.range(0, concurrency)</span>
<span class="nc" id="L187">                .boxed()</span>
<span class="nc" id="L188">                .map(outputExchanges::get)</span>
<span class="nc" id="L189">                .filter(Objects::nonNull)</span>
<span class="nc" id="L190">                .forEach(MessageExchange::shutdown);</span>
<span class="nc" id="L191">        IntStream.range(0, concurrency).boxed()</span>
<span class="nc" id="L192">                .map(workers::get)</span>
<span class="nc" id="L193">                .filter(Objects::nonNull)</span>
<span class="nc" id="L194">                .forEach(Thread::interrupt);</span>
<span class="nc" id="L195">        IntStream.range(0, concurrency).boxed()</span>
<span class="nc" id="L196">                .map(onCloseOps::get)</span>
<span class="nc" id="L197">                .filter(Objects::nonNull)</span>
<span class="nc" id="L198">                .forEach(Runnable::run);</span>
<span class="nc" id="L199">    }</span>

    @Override
    public boolean isEmpty() {
<span class="nc" id="L203">        return IntStream.range(0, concurrency)</span>
<span class="nc" id="L204">                .boxed()</span>
<span class="nc" id="L205">                .map(inputExchanges::get)</span>
<span class="nc" id="L206">                .filter(Objects::nonNull)</span>
<span class="nc" id="L207">                .map(MessageExchange::isEmpty)</span>
<span class="nc bnc" id="L208" title="All 4 branches missed.">                .reduce((e1, e2) -&gt; e1 &amp;&amp; e2)</span>
<span class="nc" id="L209">                .orElse(Boolean.FALSE);</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>